import os

# Progress tracking START #
import sys
import re
# Progress tracking STOP #

class File:

    chunkSize = 8000000
    lastChunk = 0
    filePath = ""
    fileName = ""

    loop = 0

    for location_path in sys.path:
        if (re.search('main', location_path)):
            _plugin_path = sys.path[loop-1]
        loop += 1

    # Progress tracking START #
    progress = 0
    # Progress tracking STOP #
    
    # def __init__(self):

    def GetChunk(self):

        # Progress tracking START #
        self.size = os.path.getsize(self.filePath)
        self.numberOfChunks = round(self.size/self.chunkSize)+1
        print("Size is:" + str(round(self.size / 1024 / 1024)) + "MB")
        print("Number of chunks: " + str(self.numberOfChunks))
        # Progress tracking START #

        with open(self.filePath, "rb") as file:
            # Progress tracking START #
            currentChunk = 0
            # Progress tracking STOP #

            while True:
                # Progress tracking START #
                currentChunk += 1
                # Progress tracking STOP #
                chunk = file.read(self.chunkSize)

                if not chunk:
                    # Progress tracking START #
                    self.progress = 100
                    # Progress tracking STOP #
                    break
                
                # Progress tracking START #
                self.progress = (currentChunk * 100) / self.numberOfChunks
                with open(os.path.join(self._plugin_path, 'web', 'status.json'), 'w') as _API_file:
                    _API_file.write('{"Loaded": "1","Progress": ' + str(self.progress) +', "msg": "Uploading render job...","Finished": "0"}') 
                print("Progress: " + str(self.progress) + "%")
                # Progress tracking STOP #

                yield chunk

    def GetFileName(self):
        return os.path.basename(self.filePath)
