import requests
import ssl
import json

requests.packages.urllib3.disable_warnings()


class Communication:

    addr = "http://localhost"
    key = "uHZLwsZ4bGDx41zpwS5eU8q2hzFjR80VKpn5bD1LwYdWLPVEUl3l1YrppCfxRzk33ZhuMqRLabalgAOC"

    def send(self, chunk, chunkName, jobID, jobCollectionUUID):

        print("push file")
        files = {"file": chunk}
        data = {
            "filename": chunkName, 
            "jobID": jobID,
            "jobCollectionUUID": jobCollectionUUID
            }

        r = requests.post(
            self.addr + "/files/upload?key=" + self.key,
            files=files,
            data=data,
            verify=False,
        )

        if r.ok:
            return "File uploaded!"
        else:
            return "Error uploading file!"

    def getJobLink(self, data):
        r = requests.post(
            self.addr + "/job/getLink?key=" + self.key, data=data, verify=False
        )
        response = json.loads(r.text)
        if r.ok:
            return response["url"]
        else:
            return "ups ! something went wrong :("

    def sendCreate(self, data):

        r = requests.post(
            self.addr + "/job/create?key=" + self.key, data=data, verify=False
        )

        if r.ok:
            return r.text
        else:
            return "Job not created"

    def sendCreateJobCollection(self):

        r = requests.post(
            self.addr + "/job/createJobCollection?key=" + self.key, verify=False
        )

        if r.ok:
            return r.text
        else:
            return "Job Collection not created"

    def sendRelease(self, data):

        r = requests.post(
            self.addr + "/job/release?key=" + self.key, data=data, verify=False
        )

        if r.ok:
            return r.text
        else:
            return "Job not released"
